﻿/*
//sample code SIP ADVANCED v2.0 with LineItems
//This example shows how to post data from your payment forms to CHARGE Anywhere's gateway:
//A confirmation screen will be provided after processing the data
//Enter a valid MerchantReceiptURL if you are planning to show your own Confirmation/Receipt page
*/
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using APITestPages.Components;

namespace APITestPages
{
  public partial class CartMode1 : System.Web.UI.Page
  {
    Utils utils = new Utils();
    public string mFields = "";
    public string itemsSummary = "";
    DataTable dt;
    public String mMerchantId = System.Configuration.ConfigurationManager.AppSettings["MerchantId"];
    public String mTerminalId = System.Configuration.ConfigurationManager.AppSettings["TerminalId"];

    protected void Page_Load(object sender, EventArgs e)
    {
      LBLErrorMessage.Text = "";

      if (!Page.IsPostBack)
      {
        TableCheckout.Visible = true;
        TableConfirmation.Visible = false;

        dt = new DataTable();
        dt.Columns.Add("Id");
        dt.Columns.Add("Name");
        dt.Columns.Add("Qty");
        dt.Columns.Add("Price");
        dt.Columns.Add("Subtotal");
        ViewState["LineItems"] = dt;
        DGLineItems.DataSource = ViewState["LineItems"];
        DGLineItems.DataBind();

        ManageGridFooter();
      }
    }

    private void ManageGridFooter()
    {
      int count = DGLineItems.Controls[0].Controls.Count;
      DataGridItem item = (DataGridItem)DGLineItems.Controls[0].Controls[count - 1];//Footer
      Control ControlFooter = (Label)item.FindControl("LBLGridFooter");
      Label LBLGridFooter = (Label)ControlFooter;

      if (DGLineItems.Items.Count == 0)
      {
        LBLGridFooter.Text = "No Items";
        DGLineItems.ShowFooter = true;
      }
      else
      {
        LBLGridFooter.Text = "";
        DGLineItems.ShowFooter = false;
      }
    }

    protected void ComputeSignature()
    {
      try
      {
        string MerchantId = Request.Form["MerchantId"].ToString();
        string TerminalId = Request.Form["TerminalId"].ToString();
        string Seed = Request.Form["Seed"].ToString();
        string Amount = HFAmount.Value.Trim();
        string TimeStamp = Request.Form["TimeStamp"].ToString();
        string Version = Request.Form["Version"].ToString();
        string Secret = System.Configuration.ConfigurationManager.AppSettings["Secret"];

        string CalculatedSignature = Utils.HMAC(Secret, MerchantId, TerminalId, Seed, Amount, TimeStamp, Version);

        mFields += String.Format("<input type=\"hidden\" name=\"{0}\" value=\"{1}\"/><br>\r\n", "Signature", CalculatedSignature);
        mFields += String.Format("<input type=\"hidden\" name=\"{0}\" value=\"{1}\"/><br>\r\n", "Amount", Amount);

        //Add Line Items
        string vLineItemId = "";
        string vLineItemDescription = "";
        string vLineItemProductCode = "";
        string vLineItemUOM = "";
        string vLineItemTaxable = "";
        string vLineItemCommodityCode = "";
        string vLineItemCategory = "";
        string vLineItemPrice = "";
        string vLineItemQuantity = "";
        string vLineItemTotal = "";

        //LineItems Taxes if applies
        /*string vLineItemTax1Enabled = "";
        string vLineItemTax1Description = "";
        string vLineItemTax1Rate = "";
        string vLineItemTax1Amount = "";

        string vLineItemTax2Enabled = "";
        string vLineItemTax2Description = "";
        string vLineItemTax2Rate = "";
        string vLineItemTax2Amount = "";
        */

        if (DGLineItems.Items.Count != 0)
        {
          itemsSummary = "<br>";
          itemsSummary += "<table Id='Items' rules='groups'>";
          itemsSummary += "<thead>";
          itemsSummary += "<tr>";
          itemsSummary += "<td align='center' width='150px'><b>Id</b></td>";
          itemsSummary += "<td align='center' width='75px'><b>Name</b></td>";
          itemsSummary += "<td align='center' width='75px'><b>Quantity</b></td>";
          itemsSummary += "<td align='center' width='75px'><b>Price</b></td>";
          itemsSummary += "<td align='center' width='75px'><b>Subtotal</b></td>";
          itemsSummary += "</tr>";
          itemsSummary += "</thead>";

          //double FinalPrice = 0;
          for (int i = 0; i < DGLineItems.Items.Count; i++)
          {
            Control ControlID = (TextBox)DGLineItems.Items[i].FindControl("TBItemID");
            TextBox TBItemID = (TextBox)ControlID;
            Control ControlName = (TextBox)DGLineItems.Items[i].FindControl("TBItemName");
            TextBox TBItemName = (TextBox)ControlName;
            Control ControlQty = (TextBox)DGLineItems.Items[i].FindControl("TBItemQty");
            TextBox TBItemQty = (TextBox)ControlQty;
            Control ControlPrice = (TextBox)DGLineItems.Items[i].FindControl("TBItemPrice");
            TextBox TBItemPrice = (TextBox)ControlPrice;
            Control ControlSubtotal = (TextBox)DGLineItems.Items[i].FindControl("TBItemSubtotal");
            TextBox TBItemSubtotal = (TextBox)ControlSubtotal;

            vLineItemId = TBItemID.Text.Trim();
            vLineItemDescription = TBItemName.Text.Trim();
            vLineItemQuantity = TBItemQty.Text.Trim();
            vLineItemPrice = TBItemPrice.Text.Trim();
            vLineItemTotal = TBItemSubtotal.Text.Trim();

            string LineItem = vLineItemId + "[|]" + vLineItemDescription + "[|]" + vLineItemProductCode + "[|]" + vLineItemUOM + "[|]" + vLineItemTaxable + "[|]" + vLineItemCommodityCode + "[|]" + vLineItemCategory + "[|]" + vLineItemPrice + "[|]" + vLineItemQuantity + "[|]" + vLineItemTotal;

            //Add Taxes if applies
            //LineItem += "[~]" + vLineItemTax1Enabled + "[|]" + vLineItemTax1Description + "[|]" + vLineItemTax1Rate + "[|]" + vLineItemTax1Amount + "[^]" + vLineItemTax2Enabled + "[|]" + vLineItemTax2Enabled + "[|]" + vLineItemTax2Rate + "[|]" + vLineItemTax2Amount;

            mFields += String.Format("<input type=\"hidden\" name=\"{0}\" value=\"{1}\"/><br>\r\n", "LineItem", LineItem);

            itemsSummary += "<tbody><tr>";
            itemsSummary += "<td align='center' valign='top'>" + vLineItemId + "</td>";
            itemsSummary += "<td align='center' valign='top'>" + vLineItemDescription + "</td>";
            itemsSummary += "<td align='right' valign='top'>" + vLineItemQuantity + "</td>";
            itemsSummary += "<td align='right' valign='top'>" + Convert.ToDouble(vLineItemPrice).ToString("C") + "</td>";
            itemsSummary += "<td align='right' valign='top'>" + Convert.ToDouble(vLineItemTotal).ToString("C") + "</td>";
            itemsSummary += "</tr>";

            itemsSummary += "</tbody>";
          }
          itemsSummary += "</table></br>";
        }

        ViewState["mFields"] = mFields;
      }
      catch (System.Threading.ThreadAbortException tab)
      {
      }
      catch (Exception ex)
      {
        Response.Clear();
        Response.Write("ResponseCode=0&ResponseText=Unknown Error");
      }
      finally
      {
      }
    }

    protected void BTCheckout_Click(object sender, EventArgs e)
    {
      if (HFAmount.Value == "" || Convert.ToDouble(HFAmount.Value) == 0)
      {
        LBLErrorMessage.ForeColor = System.Drawing.Color.Red;
        LBLErrorMessage.Text = "Please enter items first";
      }
      else
      {
        ComputeSignature();

        LBLFinalAmount.Text = Convert.ToDouble(HFAmount.Value).ToString("C");

        form1.Action = "https://webtest.chargeanywhere.com/APIs/PaymentFormSIP.aspx";
        //form1.Action = "http://localhost:14774/PaymentFormSIP.aspx";
        form1.Method = "post";

        TableCheckout.Visible = false;
        TableConfirmation.Visible = true;
      }
    }

    protected void BTAddItem_Click(object sender, EventArgs e)
    {
      try
      {
        if (DGLineItems.Items.Count == 0)
          LBLAmount.Text = Utils.FormatCurrency("0.00");

        if (dt == null)
        {
          dt = new DataTable();
          dt.Columns.Add("Id");
          dt.Columns.Add("Name");
          dt.Columns.Add("Qty");
          dt.Columns.Add("Price");
          dt.Columns.Add("Subtotal");
        }

        for (int i = 0; i < DGLineItems.Items.Count; i++)
        {
          Control ControlID = (TextBox)DGLineItems.Items[i].FindControl("TBItemID");
          TextBox TBItemID = (TextBox)ControlID;
          Control ControlName = (TextBox)DGLineItems.Items[i].FindControl("TBItemName");
          TextBox TBItemName = (TextBox)ControlName;
          Control ControlQty = (TextBox)DGLineItems.Items[i].FindControl("TBItemQty");
          TextBox TBItemQty = (TextBox)ControlQty;
          Control ControlPrice = (TextBox)DGLineItems.Items[i].FindControl("TBItemPrice");
          TextBox TBItemPrice = (TextBox)ControlPrice;
          Control ControlSubtotal = (TextBox)DGLineItems.Items[i].FindControl("TBItemSubtotal");
          TextBox TBItemSubtotal = (TextBox)ControlSubtotal;

          DataRow dr = dt.NewRow();
          dr["Id"] = TBItemID.Text.Trim();
          dr["Name"] = TBItemName.Text.Trim();
          dr["Qty"] = TBItemQty.Text.Trim();
          dr["Price"] = TBItemPrice.Text.Trim();
          dr["Subtotal"] = TBItemSubtotal.Text.Trim();
          dt.Rows.Add(dr);
        }

        DataRow drNew = dt.NewRow();
        drNew["Id"] = "";
        drNew["Name"] = "";
        drNew["Qty"] = "";
        drNew["Price"] = "";
        drNew["Subtotal"] = "";
        dt.Rows.Add(drNew);

        ViewState["LineItems"] = dt;
        DGLineItems.DataSource = ViewState["LineItems"];
        DGLineItems.DataBind();

        for (int i = 0; i < DGLineItems.Items.Count; i++)
        {
          Control ControlSubtotal = (TextBox)DGLineItems.Items[i].FindControl("TBItemSubtotal");
          TextBox TBItemSubtotal = (TextBox)ControlSubtotal;

          TBItemSubtotal.Attributes.Add("readonly", "readonly");
        }

        ManageGridFooter();
      }
      catch { }
    }

    protected void DGLineItems_DeleteCommand(object source, DataGridCommandEventArgs e)
    {
      try
      {
        int varIndexDelete = e.Item.ItemIndex;

        dt = (DataTable)ViewState["LineItems"];

        for (int i = 0; i < DGLineItems.Items.Count; i++)
        {
          Control ControlID = (TextBox)DGLineItems.Items[i].FindControl("TBItemID");
          TextBox TBItemID = (TextBox)ControlID;
          Control ControlName = (TextBox)DGLineItems.Items[i].FindControl("TBItemName");
          TextBox TBItemName = (TextBox)ControlName;
          Control ControlQty = (TextBox)DGLineItems.Items[i].FindControl("TBItemQty");
          TextBox TBItemQty = (TextBox)ControlQty;
          Control ControlPrice = (TextBox)DGLineItems.Items[i].FindControl("TBItemPrice");
          TextBox TBItemPrice = (TextBox)ControlPrice;
          Control ControlSubtotal = (TextBox)DGLineItems.Items[i].FindControl("TBItemSubtotal");
          TextBox TBItemSubtotal = (TextBox)ControlSubtotal;

          dt.Rows[i]["ID"] = TBItemID.Text.Trim();
          dt.Rows[i]["Name"] = TBItemName.Text.Trim();
          dt.Rows[i]["Qty"] = TBItemQty.Text.Trim();
          dt.Rows[i]["Price"] = TBItemPrice.Text.Trim();
          dt.Rows[i]["Subtotal"] = TBItemSubtotal.Text.Trim();
        }

        dt.Rows[varIndexDelete].Delete();

        ViewState["LineItems"] = dt;
        DGLineItems.DataSource = ViewState["LineItems"];
        DGLineItems.DataBind();

        for (int i = 0; i < DGLineItems.Items.Count; i++)
        {
          Control ControlSubtotal = (TextBox)DGLineItems.Items[i].FindControl("TBItemSubtotal");
          TextBox TBItemSubtotal = (TextBox)ControlSubtotal;

          TBItemSubtotal.Attributes.Add("readonly", "readonly");
        }

        ManageGridFooter();

        CalculateAmount();
      }
      catch { }
    }

    protected void CalculateAmount()
    {
      double Amount = 0;

      for (int i = 0; i < DGLineItems.Items.Count; i++)
      {
        double Price = 0;
        double Qty = 0;
        double Subtotal = 0;

        Control ControlQty = (TextBox)DGLineItems.Items[i].FindControl("TBItemQty");
        TextBox TBItemQty = (TextBox)ControlQty;
        if (TBItemQty.Text.Trim() != "")
          Qty = Convert.ToDouble(TBItemQty.Text.Trim());

        Control ControlPrice = (TextBox)DGLineItems.Items[i].FindControl("TBItemPrice");
        TextBox TBItemPrice = (TextBox)ControlPrice;
        if (TBItemPrice.Text.Trim() != "")
          Price = Convert.ToDouble(TBItemPrice.Text.Trim());

        Control ControlSubtotal = (TextBox)DGLineItems.Items[i].FindControl("TBItemSubtotal");
        TextBox TBItemSubtotal = (TextBox)ControlSubtotal;

        Subtotal = Qty * Price;
        TBItemSubtotal.Text = Subtotal.ToString("F2");

        Amount += Subtotal;
      }
      
      LBLAmount.Text = Utils.FormatCurrency(Amount);
      HFAmount.Value = Amount.ToString("F2");
    }
  }
}