﻿/*
//sample code SIP BASIC v2.0 with Recurring
//This example shows how to post data to CHARGE Anywhere's payment forms:
//A confirmation screen will be provided after processing the data
//Enter a valid MerchantReceiptURL if you are planning to show your own Confirmation/Receipt page
*/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using APITestPages.Components;

namespace APITestPages
{
  public partial class PF0DonationsRecurring : System.Web.UI.Page
  {
    Utils utils = new Utils();
    public string mFields = "";
    public String mMerchantId = System.Configuration.ConfigurationManager.AppSettings["MerchantId"];
    public String mTerminalId = System.Configuration.ConfigurationManager.AppSettings["TerminalId"];

    protected void Page_Load(object sender, EventArgs e)
    {
      LBLErrorMessage.Text = "";

      if (!Page.IsPostBack)
      {
        TableDonate.Visible = true;
        TableConfirmation.Visible = false;
      }
    }

    protected void ComputeSignature()
    {
      try
      {
        string MerchantId = Request.Form["MerchantId"].ToString();
        string TerminalId = Request.Form["TerminalId"].ToString();
        string Seed = Request.Form["Seed"].ToString();
        string Amount = TBAmount.Text.Trim();
        string TimeStamp = Request.Form["TimeStamp"].ToString();
        string Version = Request.Form["Version"].ToString();
        string Secret = System.Configuration.ConfigurationManager.AppSettings["Secret"];

        string CalculatedSignature = Utils.HMAC(Secret, MerchantId, TerminalId, Seed, Amount, TimeStamp, Version);

        mFields += String.Format("<input type=\"hidden\" name=\"{0}\" value=\"{1}\"/><br>\r\n", "Signature", CalculatedSignature);
        mFields += String.Format("<input type=\"hidden\" name=\"{0}\" value=\"{1}\"/><br>\r\n", "Amount", Amount);

        ViewState["mFields"] = mFields;
      }
      catch (System.Threading.ThreadAbortException tab)
      {
      }
      catch (Exception ex)
      {
        Response.Clear();
        Response.Write("ResponseCode=0&ResponseText=Unknown Error");
      }
      finally
      {
      }
    }

    protected void BTDonate_Click(object sender, EventArgs e)
    {
      if (TBAmount.Text.Trim() == "" || TBAmount.Text.Trim() == "0")
      {
        LBLErrorMessage.ForeColor = System.Drawing.Color.Red;
        LBLErrorMessage.Text = "Please enter an amount first";
      }
      else
      {
        ComputeSignature();

        LBLFinalAmount.Text = Convert.ToDouble(TBAmount.Text.Trim()).ToString("C");

        mFields = ViewState["mFields"].ToString();
        form1.Action = "https://webtest.chargeanywhere.com/APIs/PaymentForm.aspx";
        //form1.Action = "http://localhost:14774/PaymentForm.aspx";
        form1.Method = "post";

        TableDonate.Visible = false;
        TableConfirmation.Visible = true;
      }
    }
  }
}
